#include "feature_vector.hpp"
#include "hash.h"
#include <iostream>
#include <fstream>
#include <cmath>

struct Similarity{
	int A;
	int B;
	int C;
	int D;
	int E;
	int support;
	
	Similarity() : A(0), B(0), C(0), D(0), E(0), support(0) {}
};

struct Prediction{
	float num;
	float den;
	
	Prediction() : num(0), den(0) {} 
};
struct User;
Hash<User> dbuser;


struct User{
	feature_vector ratings;
	Hash<Similarity> sims;
	Hash<Prediction> preds;
	int sum;
	int counter;
	
	User() : sum(0), counter(0) {}
	inline float getSimilarity(int user){
		//sim(u,v) = (A-vB-u(C-nv)) / sqrt( (D+nu(u-2B)) (E+nv(v-2C)) )
		Similarity & s = sims[user];
		float u = getMean();
		float v = dbuser[user].getMean();
		return (s.A - v*s.B-u*(s.C-s.support*v)) / 
			sqrt( (s.D+s.support*u*(u-2*s.B))*(s.E+s.support*v*(v-2*s.C)));
	}
	
	inline float getMean(){
		return 1.0*sum/counter;
	}
};

Hash<feature_vector> dbitem;

//¿Podemos convertir las operaciones de multiplicación en una consulta de array?
const int squared[] = {0,1,4,9,16,25};

inline bool end_condition(node *n) { return n != 0; }

void update_similarities(int user, int item, int rating){
	feature_vector & i = dbitem[item];
	User & u = dbuser[user];
	
	for(node *n = i.begin(); n != 0; n=ne(n)){
	    if(user < n->id){
		Similarity & s = u.sims[n->id];
		s.A += rating*n->value;
		s.B += rating;
		s.C += n->value;
//		s.D += rating*rating;
//		s.E += n->value*n->value;
		s.D += squared[rating];
		s.E += squared[(int)n->value];
		++s.support;
	    }
	}
}

//¿De qué manera vamos a actualizar las predicciones?
//Esto sigue siendo una mierda...

inline void rate(int user, int item, float rating){
	User & u = dbuser[user];
	u.ratings.insert(item, rating);
	u.sum += rating;
	++u.counter;
	dbitem[item].insert(user, rating);
	//update_similarities(user, item, rating);
}

//Realiza una predicción del rating indicado
float predict(int user, int item){
	// p(u, i) = Umean + ( sum( Su,v * (Rv,i - Vmean) ) / sum( Su,v ) )
	// O lo que viene siendo:
	//	1 Tomar los votos otorgados a i
	//	2 Calcular la desviación
	//	3 Ponderarlo por la similitud al usuario
	// 	4 Agregarlos, y añadir la media de U

	feature_vector & fv = dbitem[item];
	for(node * n = fv.begin(); n != 0; n = ne(n)){
		//cout << n->value << endl;
	}
}

int main(int argc, char * argv[]){
	//Cargamos los ratings
	FILE *f = fopen(argv[1], "r");
	
	int user,item,tstamp;
	float value;
	int ratings = 0;
	cout << "Loading... ";
//	while (fscanf(f, "%d %d %f %d",&user,&item,&value,&tstamp) != EOF) {
	while (fscanf(f, "%d::%d::%f::%d",&user,&item,&value,&tstamp) != EOF) {
		//printf("%d :: %d -> %f\n", user, item, value);
		rate(user, item, value);
		if((ratings++ % 10000) == 0) {printf("%d ", ratings); fflush(stdout);}
	}
	cout << endl;


	//Cargamos el conjunto de prueba
	FILE *f_test = fopen(argv[2], "r");
	ratings = 0;
	cout << "Testing... ";
//	while (fscanf(f, "%d %d %f %d",&user,&item,&value,&tstamp) != EOF) {
	while (fscanf(f_test, "%d::%d::%f::%d",&user,&item,&value,&tstamp) != EOF) {
		//printf("%d :: %d -> %f\n", user, item, value);
		predict(user, item);
		if((ratings++ % 10000) == 0) {printf("%d ", ratings); fflush(stdout);}
	}
	cout << endl;
}
